// example: ThreeVector
#include <iostream>
#include <math.h>
using namespace std;

class ThreeVector{
    float v[3];
    
public:
    ThreeVector(){};
    ThreeVector(float x, float y, float z){ v[0]=x; v[1]=y; v[2]=z;};
    
    float get_x(){return v[0];};
    float get_y(){return v[1];};
    float get_z(){return v[2];};
    
    void set_x(float x){v[0] = x;};
    void set_y(float y){v[1] = y;};        
    void set_z(float z){v[2] = z;};
    
    float norm(){return sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);};
    float operator * (const ThreeVector& y){return v[0]*y.v[0] + v[1]*y.v[1] +v[2]*y.v[2];}
    
    ThreeVector vmult(ThreeVector);
};

ThreeVector ThreeVector::vmult(ThreeVector second){
  ThreeVector out;
  out.v[0] = v[1]*second.v[2] - v[2]*second.v[1];
  out.v[1] = v[2]*second.v[0] - v[0]*second.v[2];
  out.v[2] = v[0]*second.v[1] - v[1]*second.v[0];
  return out;
};



class Parralelogram{
  ThreeVector first;
  ThreeVector second;
public:
  Parralelogram(ThreeVector f, ThreeVector second): first(f), second(second){};
  float get_area() {return first.vmult(second).norm();}
};


int main () {
  ThreeVector a(1,2,3);
  ThreeVector b(1,0,0);
  cout << "norm a " << a.norm() << endl;
  cout << "norm b " << b.norm() << endl;
  cout << "a*b= " << a*b << endl;
  Parralelogram P(a,b);
  cout << "area of parralelogram " << P.get_area()<<endl;
}
